import java.util.Random;


public class ConsoleStarter implements Present{

	public World world;

	private static Random r = new Random(System.currentTimeMillis());
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ConsoleStarter s = new ConsoleStarter();
		
		if ( args.length!=2) return;
		String file = args[0];
		long w = Long.parseLong(args[1]);
		int p = Integer.parseInt(args[2]);		
		s.world = new World(file,w,p);
		for (int i = 3; i < args.length; i++) {
			int x =r.nextInt(s.world.getWidth()-1)+1;
			int y =r.nextInt(s.world.getHeight()-1)+1;
			while (!s.world.freePlace(x, y)){
				x =r.nextInt(s.world.getWidth()-1)+1;
				y =r.nextInt(s.world.getHeight()-1)+1;
			}
			Class c;
			try {
				c = ClassLoader.getSystemClassLoader().loadClass(args[i]);
				Agent agent = (Agent)c.newInstance();  
				s.world.addAgent(agent, x, y);	
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
						
			
			
			
		}

		s.world.presenter = s;		
	 	s.world.run(); 
	}
	
	public void redraw(){
		System.out.println(world.print());
		System.out.println();
		System.out.println();
	}

	
	
}
