import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.lang.reflect.Constructor;
import java.util.Random;

public class GuiStarter extends Frame implements Present{

	public World world;
	private static Random r = new Random(System.currentTimeMillis());
	public TextArea area;
	Button b;	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		GuiStarter s = new GuiStarter();
		
		String file = args[0];
		long w = Long.parseLong(args[1]);
		int p = Integer.parseInt(args[2]);		
		s.world = new World(file,w,p);
		for (int i = 3; i < args.length; i++) {
			int x =r.nextInt(s.world.getWidth()-1)+1;
			int y =r.nextInt(s.world.getHeight()-1)+1;
			while (!s.world.freePlace(x, y)){
				x =r.nextInt(s.world.getWidth()-1)+1;
				y =r.nextInt(s.world.getHeight()-1)+1;
			}
			Class c;
			try {
				c = ClassLoader.getSystemClassLoader().loadClass(args[i]);
				Agent agent = (Agent)c.newInstance();  
				s.world.addAgent(agent, x, y);	
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
						
			
			
			
		}

		s.world.presenter = s;		
		s.init();
		
	    s.setVisible(true);	  	   
	}
	
	public void redraw(){
    	area.setText("");
		area.setText(world.print());
	}

	public void init(){

		  setSize(500,500);
		  repaint();
	      Panel p;
	      p = new Panel();
	      p.setSize(500,500);
	      p.setLayout(new BorderLayout());
	      b = new Button("Run");
	      p.add(BorderLayout.NORTH,b);
	      b.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent arg0) {
				world.run();
				b.setEnabled((false));
			}
	    	  
	      });
	      area = new TextArea();
	      area.setEditable(false);
	      
	      p.add(BorderLayout.CENTER,area);
	      area.setFont(new Font("Monospaced",Font.PLAIN,13));
	      add( p);
	      addWindowListener(new WindowAdapter(){
	    	 public void windowClosing(WindowEvent arg0) {
	    		System.exit(0);
	    	
	    	} 
	      });
	      repaint();
	}
	
	
}
